searchNodes=[{"doc":"Provides functions to access the public methods of the Astra Auth API for databases hosted on https://astra.datastax.com.","ref":"Astra.Auth.html","title":"Astra.Auth","type":"module"},{"doc":"Get a fresh auth token from Astra. Automatically called by the TokenManager appParametersusername: Astra database user namepassword: password for the userExamples &gt; Astra.Auth.authorize_user(&quot;operator&quot;, &quot;bad_password!&quot;) {:ok, %{authToken: &quot;3f9d03af-e29d-40d5-9fe1-c77a2ff6a40a&quot;}}","ref":"Astra.Auth.html#authorize_user/2","title":"Astra.Auth.authorize_user/2","type":"function"},{"doc":"Provides functions to access the public methods of the Document API for databases hosted on https://astra.datastax.com. Astra's Document API is implemented using the stargate project, https://stargate.io. Swagger docs for this interface are available here https://docs.astra.datastax.com/reference#namespaces-1.If required, raw access to the Astra REST Document API can be obtained through the Astra.Document.Http module.","ref":"Astra.Document.html","title":"Astra.Document","type":"module"},{"doc":"delete a documentParametersnamespace: namespace namecollection: name of the document collectionid: the id of the document to destroyExamples &gt; Astra.Document.delete_doc(&quot;test&quot;, &quot;docs&quot;, id) {:ok, []}","ref":"Astra.Document.html#delete_doc/3","title":"Astra.Document.delete_doc/3","type":"function"},{"doc":"delete a sub documentParametersnamespace: namespace namecollection: name of the document collectionid: the id of the document to destroypath: the path to the subdocument. Nested paths can be matched by joining the keys with a \\, ex. address\\city Examples doc = %{ name: &quot;other-stuff&quot;, other: %{ first: &quot;thing&quot;, last: &quot;thing&quot;} } &gt; {:ok, %{documentId: id}} = Astra.Document.post_doc(&quot;test&quot;, &quot;docs&quot;, doc) &gt; Astra.Document.get_sub_doc(&quot;test&quot;, &quot;docs&quot;, id, &quot;other&quot;) {:ok, %{ first: &quot;thing&quot;, last: &quot;thing&quot;}}","ref":"Astra.Document.html#delete_sub_doc/4","title":"Astra.Document.delete_sub_doc/4","type":"function"},{"doc":"get a document by idParametersnamespace: namespace namecollection: name of the document collectionid: the id of the document to retrieve Examples &gt; Astra.Document.get_doc(&quot;test&quot;, &quot;docs&quot;, id) {:ok, %{name: &quot;other-stuff&quot;, other: &quot;This makes no sense&quot;}}","ref":"Astra.Document.html#get_doc/3","title":"Astra.Document.get_doc/3","type":"function"},{"doc":"get a sub document by idParametersnamespace: namespace namecollection: name of the document collectionid: the id of the document to retrievepath: the path to the subdocument. Nested paths can be matched by joining the keys with a \\, ex. address\\city Examples doc = %{ name: &quot;other-stuff&quot;, other: %{ first: &quot;thing&quot;, last: &quot;thing&quot;} } &gt; {:ok, %{documentId: id}} = Astra.Document.post_doc(&quot;test&quot;, &quot;docs&quot;, doc) &gt; Astra.Document.get_sub_doc(&quot;test&quot;, &quot;docs&quot;, id, &quot;other&quot;) {:ok, %{ first: &quot;thing&quot;, last: &quot;thing&quot;}}","ref":"Astra.Document.html#get_sub_doc/4","title":"Astra.Document.get_sub_doc/4","type":"function"},{"doc":"update part of a documentParametersnamespace: namespace namecollection: name of the document collectionid: the id of the documentExamples &gt; Astra.Document.patch_doc(&quot;test&quot;, &quot;docs&quot;, id, %{name: &quot;fred&quot;}) {:ok, nil}","ref":"Astra.Document.html#patch_doc/4","title":"Astra.Document.patch_doc/4","type":"function"},{"doc":"update part of a sub documentParametersnamespace: namespace namecollection: name of the document collectionid: the id of the document'path: the path to the subdocument. Nested paths can be matched by joining the keys with a \\, ex. address\\city patch: a map of attributes to match. Sub-document attributes not in the patch Map will remain as is.Examples &gt; Astra.Document.patch_sub_doc(&quot;test&quot;, &quot;docs&quot;, id, &quot;other&quot;, %{first: &quot;object&quot;}) {:ok, nil}","ref":"Astra.Document.html#patch_sub_doc/5","title":"Astra.Document.patch_sub_doc/5","type":"function"},{"doc":"add a new document, id will be an auto generated uuidParametersnamespace: namespace namecollection: name of the document collectiondoc: the new document. Examples &gt; doc = %{ name: &quot;other-stuff&quot;, other: %{ first: &quot;thing&quot;, last: &quot;thing&quot;} } &gt; Astra.Document.post_doc(&quot;test&quot;, &quot;docs&quot;, doc) {:ok, %{documentId: &quot;3f9d03af-e29d-40d5-9fe1-c77a2ff6a40a&quot;}}","ref":"Astra.Document.html#post_doc/3","title":"Astra.Document.post_doc/3","type":"function"},{"doc":"replace a documentParametersnamespace: namespace namecollection: name of the document collectionid: the id of the documentdoc: the new document. Any existing document at the id will be removed.Examples &gt; doc = %{ name: &quot;other-stuff&quot;, other: %{ first: &quot;thing&quot;, last: &quot;thing&quot;} } &gt; Astra.Document.put_doc(&quot;test&quot;, &quot;docs&quot;, uuid, doc)","ref":"Astra.Document.html#put_doc/4","title":"Astra.Document.put_doc/4","type":"function"},{"doc":"replace a sub documentParametersnamespace: namespace namecollection: name of the document collectionid: the id of the documentpath: the path to the subdocument. Nested paths can be matched by joining the keys with a \\, ex. address\\city doc: the new document. Any existing document at the id will be removed.Examples &gt; doc = %{ name: &quot;other-stuff&quot;, other: %{ first: &quot;thing&quot;, last: &quot;thing&quot;} } &gt; Astra.Document.put_doc(&quot;test&quot;, &quot;docs&quot;, uuid, doc)","ref":"Astra.Document.html#put_sub_doc/5","title":"Astra.Document.put_sub_doc/5","type":"function"},{"doc":"search for documents in a collectionParametersnamespace: namespace namecollection: name of the document collectionwhere: search clause for matching documentsoptions: Valid options [:fields, :&quot;page-size&quot;, :&quot;page-state&quot;, :sort]Examples &gt; query = %{ other: %{ &quot;$eq&quot;: uuid } } &gt; Astra.Document.search_docs(&quot;test&quot;, &quot;docs&quot;, query, %{&quot;page-size&quot;: 20})","ref":"Astra.Document.html#search_docs/4","title":"Astra.Document.search_docs/4","type":"function"},{"doc":"Astra.Rest provides functions to access the public methods of the REST interface for databases hosed on https://astra.datastax.com.Astra's REST interface is implemented using the stargate project, https://stargate.io. Swagger docs for this interface are available here https://docs.astra.datastax.com/reference#keyspaces-2.If required, raw access to the Astra REST api can be obtained through the Astra.Rest.Http module.","ref":"Astra.Rest.html","title":"Astra.Rest","type":"module"},{"doc":"Add a row. All fields in the row are optional except for fields defined in the PRIMARY KEY of the table definition.Parameterskeyspace: the keyspace containing the target tabletable: the table containing the entity we are retrievingentity: a Map of the attributes of the row we are adding ex. %{ id: &quot;83b8d85d-bd33-4650-8b9d-b43354187114&quot;, name: &quot;test row&quot; }Examples &gt; new_row = %{id: &quot;83b8d85d-bd33-4650-8b9d-b43354187114&quot;, name: &quot;test row&quot;} &gt; Astra.Rest.add_row(&quot;test&quot;, &quot;thing&quot;, new_row) {:ok, %{id: &quot;83b8d85d-bd33-4650-8b9d-b43354187114&quot;}}","ref":"Astra.Rest.html#add_row/3","title":"Astra.Rest.add_row/3","type":"function"},{"doc":"Remove a row.Parameterskeyspace: the keyspace containing the target tabletable: the table containing the entity we are retrievingkey: a primary key, if it contains multiple fields they should be seperated with \\Examples &gt; new_row = %{id: &quot;83b8d85d-bd33-4650-8b9d-b43354187114&quot;, name: &quot;test row&quot;} &gt; Astra.Rest.delete_row(&quot;test&quot;, &quot;thing&quot;, &quot;83b8d85d-bd33-4650-8b9d-b43354187114&quot;) {:ok, []]}","ref":"Astra.Rest.html#delete_row/3","title":"Astra.Rest.delete_row/3","type":"function"},{"doc":"get_row retrieves one or more rows based on the keyspace, table and primary_key. Primary keys that span multiple fields should be delimeted with a \\ ex. &quot;123\\tuesday&quot;.Examples&gt; Astra.Rest.get_row(&quot;test&quot;, &quot;thing&quot;, &quot;83b8d85d-bd33-4650-8b9d-b43354187114&quot;) {:ok, [%{id: &quot;83b8d85d-bd33-4650-8b9d-b43354187114&quot;, name: &quot;test row&quot;}]}","ref":"Astra.Rest.html#get_row/3","title":"Astra.Rest.get_row/3","type":"function"},{"doc":"Similar to Astra.Rest.add_row/3, the key needs to be provided explicity.Parameterskeyspace: the keyspace containing the target tabletable: the table containing the entity we are retrievingkey: a primary key, if it contains multiple fields they should be seperated with \\entity: a Map of the attributes of the row we are adding ex. %{ id: &quot;83b8d85d-bd33-4650-8b9d-b43354187114&quot;, name: &quot;test row&quot; }Examples &gt; new_row = %{name: &quot;test row&quot;} &gt; Astra.Rest.replace_row(&quot;test&quot;, &quot;thing&quot;, &quot;83b8d85d-bd33-4650-8b9d-b43354187115&quot;, new_row) {:ok, %{name: &quot;test row&quot;}} &gt; Astra.Rest.get_row(&quot;test&quot;, &quot;thing&quot;, &quot;83b8d85d-bd33-4650-8b9d-b43354187115&quot;) {:ok, [%{id: &quot;83b8d85d-bd33-4650-8b9d-b43354187115&quot;, name: &quot;test row&quot;}]}","ref":"Astra.Rest.html#replace_row/4","title":"Astra.Rest.replace_row/4","type":"function"},{"doc":"Search for rows in a table. The following operators are available for the query: $eq, $lt, $lte, $gt, $gte, $ne, and $exists.Please note that some restrictions exist for searches:Search cannot be on a PRIMARY KEY field, unless a composite primary key is being used.Search fields will require some form of secondary index. SAI is usually the best choice https://docs.astra.datastax.com/docs/using-storage-attached-indexing-saiExample of creating an SAI index on a table:CREATE TABLE thing ( id text PRIMARY KEY, name text ) CREATE CUSTOM INDEX things_name_idx ON thing (name) USING &#39;StorageAttachedIndex&#39; WITH OPTIONS = {&#39;normalize&#39;: &#39;true&#39;, &#39;case_sensitive&#39;: &#39;false&#39;};Parameterskeyspace: the keyspace containing the target tabletable: the table containing the entity we are retrievingquery: the search query for the table. ex. %{name: %{&quot;$in&quot;: [&quot;red&quot;, &quot;blue&quot;]}}Examples &gt; Astra.Rest.search_table(&quot;test&quot;, &quot;thing&quot;, %{name: %{&quot;$eq&quot;: &quot;test row&quot;}})","ref":"Astra.Rest.html#search_table/3","title":"Astra.Rest.search_table/3","type":"function"},{"doc":"Update part of a row, only fields provided in the entity will be updated.Parameterskeyspace: the keyspace containing the target tabletable: the table containing the entity we are retrievingkey: a primary key, if it contains multiple fields they should be seperated with \\entity: a Map of the attributes of the row we are adding ex. %{ id: &quot;83b8d85d-bd33-4650-8b9d-b43354187114&quot;, name: &quot;test row&quot; }Examples &gt; new_row = %{id: &quot;83b8d85d-bd33-4650-8b9d-b43354187114&quot;, name: &quot;test row&quot;} &gt; Astra.Rest.add_row(&quot;test&quot;, &quot;thing&quot;, new_row) {:ok, %{id: &quot;83b8d85d-bd33-4650-8b9d-b43354187114&quot;}}","ref":"Astra.Rest.html#update_partial_row/4","title":"Astra.Rest.update_partial_row/4","type":"function"},{"doc":"Astra.Auth.Http provides direct access to all HTTP methods implemented in HTTPoison. It is used by Astra.Rest to add required headers and security to request, but could also be used to directly access unimplemented functionality in the future.","ref":"Astra.Auth.Http.html","title":"Astra.Auth.Http","type":"module"},{"doc":"Issues a DELETE request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Auth.Http.html#delete/3","title":"Astra.Auth.Http.delete/3","type":"function"},{"doc":"Issues a DELETE request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Auth.Http.html#delete!/3","title":"Astra.Auth.Http.delete!/3","type":"function"},{"doc":"Issues a GET request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Auth.Http.html#get/3","title":"Astra.Auth.Http.get/3","type":"function"},{"doc":"Issues a GET request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Auth.Http.html#get!/3","title":"Astra.Auth.Http.get!/3","type":"function"},{"doc":"Issues a HEAD request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Auth.Http.html#head/3","title":"Astra.Auth.Http.head/3","type":"function"},{"doc":"Issues a HEAD request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Auth.Http.html#head!/3","title":"Astra.Auth.Http.head!/3","type":"function"},{"doc":"","ref":"Astra.Auth.Http.html#json!/1","title":"Astra.Auth.Http.json!/1","type":"function"},{"doc":"Issues an OPTIONS request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Auth.Http.html#options/3","title":"Astra.Auth.Http.options/3","type":"function"},{"doc":"Issues a OPTIONS request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Auth.Http.html#options!/3","title":"Astra.Auth.Http.options!/3","type":"function"},{"doc":"","ref":"Astra.Auth.Http.html#parse_response/1","title":"Astra.Auth.Http.parse_response/1","type":"function"},{"doc":"Issues a PATCH request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Auth.Http.html#patch/4","title":"Astra.Auth.Http.patch/4","type":"function"},{"doc":"Issues a PATCH request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Auth.Http.html#patch!/4","title":"Astra.Auth.Http.patch!/4","type":"function"},{"doc":"Issues a POST request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Auth.Http.html#post/4","title":"Astra.Auth.Http.post/4","type":"function"},{"doc":"Issues a POST request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Auth.Http.html#post!/4","title":"Astra.Auth.Http.post!/4","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_headers/1.","ref":"Astra.Auth.Http.html#process_headers/1","title":"Astra.Auth.Http.process_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_body/1.","ref":"Astra.Auth.Http.html#process_request_body/1","title":"Astra.Auth.Http.process_request_body/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_headers/1.","ref":"Astra.Auth.Http.html#process_request_headers/1","title":"Astra.Auth.Http.process_request_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_options/1.","ref":"Astra.Auth.Http.html#process_request_options/1","title":"Astra.Auth.Http.process_request_options/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_params/1.","ref":"Astra.Auth.Http.html#process_request_params/1","title":"Astra.Auth.Http.process_request_params/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_url/1.","ref":"Astra.Auth.Http.html#process_request_url/1","title":"Astra.Auth.Http.process_request_url/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response/1.","ref":"Astra.Auth.Http.html#process_response/1","title":"Astra.Auth.Http.process_response/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_body/1.","ref":"Astra.Auth.Http.html#process_response_body/1","title":"Astra.Auth.Http.process_response_body/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_chunk/1.","ref":"Astra.Auth.Http.html#process_response_chunk/1","title":"Astra.Auth.Http.process_response_chunk/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_headers/1.","ref":"Astra.Auth.Http.html#process_response_headers/1","title":"Astra.Auth.Http.process_response_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_status_code/1.","ref":"Astra.Auth.Http.html#process_response_status_code/1","title":"Astra.Auth.Http.process_response_status_code/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_status_code/1.","ref":"Astra.Auth.Http.html#process_status_code/1","title":"Astra.Auth.Http.process_status_code/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_url/1.","ref":"Astra.Auth.Http.html#process_url/1","title":"Astra.Auth.Http.process_url/1","type":"function"},{"doc":"Issues a PUT request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Auth.Http.html#put/4","title":"Astra.Auth.Http.put/4","type":"function"},{"doc":"Issues a PUT request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Auth.Http.html#put!/4","title":"Astra.Auth.Http.put!/4","type":"function"},{"doc":"Issues an HTTP request using a Request struct.This function returns {:ok, response}, {:ok, async_response}, or {:ok, maybe_redirect} if the request is successful, {:error, reason} otherwise.Redirect handlingIf the option :follow_redirect is given, HTTP redirects are automatically follow if the method is set to :get or :head and the response's status_code is 301, 302 or 307.If the method is set to :post, then the only status_code that get's automatically followed is 303.If any other method or status_code is returned, then this function returns a returns a {:ok, %HTTPoison.MaybeRedirect{}} containing the redirect_url for you to re-request with the method set to :get.Examplesrequest = %HTTPoison.Request{ method: :post, url: &quot;https://my.website.com&quot;, body: &quot;{\\&quot;foo\\&quot;: 3}&quot;, headers: [{&quot;Accept&quot;, &quot;application/json&quot;}] } request(request)","ref":"Astra.Auth.Http.html#request/1","title":"Astra.Auth.Http.request/1","type":"function"},{"doc":"Issues an HTTP request with the given method to the given url.This function is usually used indirectly by get/3, post/4, put/4, etcArgs:method - HTTP method as an atom (:get, :head, :post, :put, :delete, etc.)url - target url as a binary string or char listbody - request body. See more belowheaders - HTTP headers as an orddict (e.g., [{&quot;Accept&quot;, &quot;application/json&quot;}])options - Keyword list of optionsBody: see type HTTPoison.RequestOptions: see type HTTPoison.RequestThis function returns {:ok, response}, {:ok, async_response}, or {:ok, maybe_redirect} if the request is successful, {:error, reason} otherwise.Redirect handlingIf the option :follow_redirect is given, HTTP redirects are automatically follow if the method is set to :get or :head and the response's status_code is 301, 302 or 307.If the method is set to :post, then the only status_code that get's automatically followed is 303.If any other method or status_code is returned, then this function returns a returns a {:ok, %HTTPoison.MaybeRedirect{}} containing the redirect_url for you to re-request with the method set to :get.Examplesrequest(:post, &quot;https://my.website.com&quot;, &quot;{\\&quot;foo\\&quot;: 3}&quot;, [{&quot;Accept&quot;, &quot;application/json&quot;}])","ref":"Astra.Auth.Http.html#request/5","title":"Astra.Auth.Http.request/5","type":"function"},{"doc":"Issues an HTTP request with the given method to the given url, raising an exception in case of failure.request!/5 works exactly like request/5 but it returns just the response in case of a successful request, raising an exception in case the request fails.","ref":"Astra.Auth.Http.html#request!/5","title":"Astra.Auth.Http.request!/5","type":"function"},{"doc":"Starts HTTPoison and its dependencies.","ref":"Astra.Auth.Http.html#start/0","title":"Astra.Auth.Http.start/0","type":"function"},{"doc":"Requests the next message to be streamed for a given HTTPoison.AsyncResponse.See request!/5 for more detailed information.","ref":"Astra.Auth.Http.html#stream_next/1","title":"Astra.Auth.Http.stream_next/1","type":"function"},{"doc":"","ref":"Astra.Auth.Http.html#t:body/0","title":"Astra.Auth.Http.body/0","type":"type"},{"doc":"","ref":"Astra.Auth.Http.html#t:headers/0","title":"Astra.Auth.Http.headers/0","type":"type"},{"doc":"","ref":"Astra.Auth.Http.html#t:method/0","title":"Astra.Auth.Http.method/0","type":"type"},{"doc":"","ref":"Astra.Auth.Http.html#t:options/0","title":"Astra.Auth.Http.options/0","type":"type"},{"doc":"","ref":"Astra.Auth.Http.html#t:params/0","title":"Astra.Auth.Http.params/0","type":"type"},{"doc":"","ref":"Astra.Auth.Http.html#t:request/0","title":"Astra.Auth.Http.request/0","type":"type"},{"doc":"","ref":"Astra.Auth.Http.html#t:url/0","title":"Astra.Auth.Http.url/0","type":"type"},{"doc":"Astra.Document.Http provides direct access to all HTTP methods implemented in HTTPoison. It is used by Astra.Document to add required headers and security to request, but could also be used to directly access unimplemented functionality in the future.","ref":"Astra.Document.Http.html","title":"Astra.Document.Http","type":"module"},{"doc":"Issues a DELETE request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Document.Http.html#delete/3","title":"Astra.Document.Http.delete/3","type":"function"},{"doc":"Issues a DELETE request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Document.Http.html#delete!/3","title":"Astra.Document.Http.delete!/3","type":"function"},{"doc":"Issues a GET request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Document.Http.html#get/3","title":"Astra.Document.Http.get/3","type":"function"},{"doc":"Issues a GET request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Document.Http.html#get!/3","title":"Astra.Document.Http.get!/3","type":"function"},{"doc":"Issues a HEAD request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Document.Http.html#head/3","title":"Astra.Document.Http.head/3","type":"function"},{"doc":"Issues a HEAD request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Document.Http.html#head!/3","title":"Astra.Document.Http.head!/3","type":"function"},{"doc":"","ref":"Astra.Document.Http.html#json!/1","title":"Astra.Document.Http.json!/1","type":"function"},{"doc":"Issues an OPTIONS request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Document.Http.html#options/3","title":"Astra.Document.Http.options/3","type":"function"},{"doc":"Issues a OPTIONS request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Document.Http.html#options!/3","title":"Astra.Document.Http.options!/3","type":"function"},{"doc":"","ref":"Astra.Document.Http.html#parse_response/1","title":"Astra.Document.Http.parse_response/1","type":"function"},{"doc":"Issues a PATCH request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Document.Http.html#patch/4","title":"Astra.Document.Http.patch/4","type":"function"},{"doc":"Issues a PATCH request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Document.Http.html#patch!/4","title":"Astra.Document.Http.patch!/4","type":"function"},{"doc":"Issues a POST request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Document.Http.html#post/4","title":"Astra.Document.Http.post/4","type":"function"},{"doc":"Issues a POST request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Document.Http.html#post!/4","title":"Astra.Document.Http.post!/4","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_headers/1.","ref":"Astra.Document.Http.html#process_headers/1","title":"Astra.Document.Http.process_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_body/1.","ref":"Astra.Document.Http.html#process_request_body/1","title":"Astra.Document.Http.process_request_body/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_headers/1.","ref":"Astra.Document.Http.html#process_request_headers/1","title":"Astra.Document.Http.process_request_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_options/1.","ref":"Astra.Document.Http.html#process_request_options/1","title":"Astra.Document.Http.process_request_options/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_params/1.","ref":"Astra.Document.Http.html#process_request_params/1","title":"Astra.Document.Http.process_request_params/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_url/1.","ref":"Astra.Document.Http.html#process_request_url/1","title":"Astra.Document.Http.process_request_url/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response/1.","ref":"Astra.Document.Http.html#process_response/1","title":"Astra.Document.Http.process_response/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_body/1.","ref":"Astra.Document.Http.html#process_response_body/1","title":"Astra.Document.Http.process_response_body/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_chunk/1.","ref":"Astra.Document.Http.html#process_response_chunk/1","title":"Astra.Document.Http.process_response_chunk/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_headers/1.","ref":"Astra.Document.Http.html#process_response_headers/1","title":"Astra.Document.Http.process_response_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_status_code/1.","ref":"Astra.Document.Http.html#process_response_status_code/1","title":"Astra.Document.Http.process_response_status_code/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_status_code/1.","ref":"Astra.Document.Http.html#process_status_code/1","title":"Astra.Document.Http.process_status_code/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_url/1.","ref":"Astra.Document.Http.html#process_url/1","title":"Astra.Document.Http.process_url/1","type":"function"},{"doc":"Issues a PUT request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Document.Http.html#put/4","title":"Astra.Document.Http.put/4","type":"function"},{"doc":"Issues a PUT request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Document.Http.html#put!/4","title":"Astra.Document.Http.put!/4","type":"function"},{"doc":"Issues an HTTP request using a Request struct.This function returns {:ok, response}, {:ok, async_response}, or {:ok, maybe_redirect} if the request is successful, {:error, reason} otherwise.Redirect handlingIf the option :follow_redirect is given, HTTP redirects are automatically follow if the method is set to :get or :head and the response's status_code is 301, 302 or 307.If the method is set to :post, then the only status_code that get's automatically followed is 303.If any other method or status_code is returned, then this function returns a returns a {:ok, %HTTPoison.MaybeRedirect{}} containing the redirect_url for you to re-request with the method set to :get.Examplesrequest = %HTTPoison.Request{ method: :post, url: &quot;https://my.website.com&quot;, body: &quot;{\\&quot;foo\\&quot;: 3}&quot;, headers: [{&quot;Accept&quot;, &quot;application/json&quot;}] } request(request)","ref":"Astra.Document.Http.html#request/1","title":"Astra.Document.Http.request/1","type":"function"},{"doc":"Issues an HTTP request with the given method to the given url.This function is usually used indirectly by get/3, post/4, put/4, etcArgs:method - HTTP method as an atom (:get, :head, :post, :put, :delete, etc.)url - target url as a binary string or char listbody - request body. See more belowheaders - HTTP headers as an orddict (e.g., [{&quot;Accept&quot;, &quot;application/json&quot;}])options - Keyword list of optionsBody: see type HTTPoison.RequestOptions: see type HTTPoison.RequestThis function returns {:ok, response}, {:ok, async_response}, or {:ok, maybe_redirect} if the request is successful, {:error, reason} otherwise.Redirect handlingIf the option :follow_redirect is given, HTTP redirects are automatically follow if the method is set to :get or :head and the response's status_code is 301, 302 or 307.If the method is set to :post, then the only status_code that get's automatically followed is 303.If any other method or status_code is returned, then this function returns a returns a {:ok, %HTTPoison.MaybeRedirect{}} containing the redirect_url for you to re-request with the method set to :get.Examplesrequest(:post, &quot;https://my.website.com&quot;, &quot;{\\&quot;foo\\&quot;: 3}&quot;, [{&quot;Accept&quot;, &quot;application/json&quot;}])","ref":"Astra.Document.Http.html#request/5","title":"Astra.Document.Http.request/5","type":"function"},{"doc":"Issues an HTTP request with the given method to the given url, raising an exception in case of failure.request!/5 works exactly like request/5 but it returns just the response in case of a successful request, raising an exception in case the request fails.","ref":"Astra.Document.Http.html#request!/5","title":"Astra.Document.Http.request!/5","type":"function"},{"doc":"Starts HTTPoison and its dependencies.","ref":"Astra.Document.Http.html#start/0","title":"Astra.Document.Http.start/0","type":"function"},{"doc":"Requests the next message to be streamed for a given HTTPoison.AsyncResponse.See request!/5 for more detailed information.","ref":"Astra.Document.Http.html#stream_next/1","title":"Astra.Document.Http.stream_next/1","type":"function"},{"doc":"","ref":"Astra.Document.Http.html#t:body/0","title":"Astra.Document.Http.body/0","type":"type"},{"doc":"","ref":"Astra.Document.Http.html#t:headers/0","title":"Astra.Document.Http.headers/0","type":"type"},{"doc":"","ref":"Astra.Document.Http.html#t:method/0","title":"Astra.Document.Http.method/0","type":"type"},{"doc":"","ref":"Astra.Document.Http.html#t:options/0","title":"Astra.Document.Http.options/0","type":"type"},{"doc":"","ref":"Astra.Document.Http.html#t:params/0","title":"Astra.Document.Http.params/0","type":"type"},{"doc":"","ref":"Astra.Document.Http.html#t:request/0","title":"Astra.Document.Http.request/0","type":"type"},{"doc":"","ref":"Astra.Document.Http.html#t:url/0","title":"Astra.Document.Http.url/0","type":"type"},{"doc":"Astra.Rest.Http provides direct access to all HTTP methods implemented in HTTPoison. It is used by Astra.Rest to add required headers and security to request, but could also be used to directly access unimplemented functionality in the future.","ref":"Astra.Rest.Http.html","title":"Astra.Rest.Http","type":"module"},{"doc":"Issues a DELETE request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Rest.Http.html#delete/3","title":"Astra.Rest.Http.delete/3","type":"function"},{"doc":"Issues a DELETE request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Rest.Http.html#delete!/3","title":"Astra.Rest.Http.delete!/3","type":"function"},{"doc":"Issues a GET request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Rest.Http.html#get/3","title":"Astra.Rest.Http.get/3","type":"function"},{"doc":"Issues a GET request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Rest.Http.html#get!/3","title":"Astra.Rest.Http.get!/3","type":"function"},{"doc":"Issues a HEAD request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Rest.Http.html#head/3","title":"Astra.Rest.Http.head/3","type":"function"},{"doc":"Issues a HEAD request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Rest.Http.html#head!/3","title":"Astra.Rest.Http.head!/3","type":"function"},{"doc":"","ref":"Astra.Rest.Http.html#json!/1","title":"Astra.Rest.Http.json!/1","type":"function"},{"doc":"Issues an OPTIONS request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Rest.Http.html#options/3","title":"Astra.Rest.Http.options/3","type":"function"},{"doc":"Issues a OPTIONS request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Rest.Http.html#options!/3","title":"Astra.Rest.Http.options!/3","type":"function"},{"doc":"","ref":"Astra.Rest.Http.html#parse_response/1","title":"Astra.Rest.Http.parse_response/1","type":"function"},{"doc":"Issues a PATCH request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Rest.Http.html#patch/4","title":"Astra.Rest.Http.patch/4","type":"function"},{"doc":"Issues a PATCH request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Rest.Http.html#patch!/4","title":"Astra.Rest.Http.patch!/4","type":"function"},{"doc":"Issues a POST request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Rest.Http.html#post/4","title":"Astra.Rest.Http.post/4","type":"function"},{"doc":"Issues a POST request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Rest.Http.html#post!/4","title":"Astra.Rest.Http.post!/4","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_headers/1.","ref":"Astra.Rest.Http.html#process_headers/1","title":"Astra.Rest.Http.process_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_body/1.","ref":"Astra.Rest.Http.html#process_request_body/1","title":"Astra.Rest.Http.process_request_body/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_headers/1.","ref":"Astra.Rest.Http.html#process_request_headers/1","title":"Astra.Rest.Http.process_request_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_options/1.","ref":"Astra.Rest.Http.html#process_request_options/1","title":"Astra.Rest.Http.process_request_options/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_params/1.","ref":"Astra.Rest.Http.html#process_request_params/1","title":"Astra.Rest.Http.process_request_params/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_request_url/1.","ref":"Astra.Rest.Http.html#process_request_url/1","title":"Astra.Rest.Http.process_request_url/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response/1.","ref":"Astra.Rest.Http.html#process_response/1","title":"Astra.Rest.Http.process_response/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_body/1.","ref":"Astra.Rest.Http.html#process_response_body/1","title":"Astra.Rest.Http.process_response_body/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_chunk/1.","ref":"Astra.Rest.Http.html#process_response_chunk/1","title":"Astra.Rest.Http.process_response_chunk/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_headers/1.","ref":"Astra.Rest.Http.html#process_response_headers/1","title":"Astra.Rest.Http.process_response_headers/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_response_status_code/1.","ref":"Astra.Rest.Http.html#process_response_status_code/1","title":"Astra.Rest.Http.process_response_status_code/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_status_code/1.","ref":"Astra.Rest.Http.html#process_status_code/1","title":"Astra.Rest.Http.process_status_code/1","type":"function"},{"doc":"Callback implementation for HTTPoison.Base.process_url/1.","ref":"Astra.Rest.Http.html#process_url/1","title":"Astra.Rest.Http.process_url/1","type":"function"},{"doc":"Issues a PUT request to the given url.Returns {:ok, response} if the request is successful, {:error, reason} otherwise.See request/5 for more detailed information.","ref":"Astra.Rest.Http.html#put/4","title":"Astra.Rest.Http.put/4","type":"function"},{"doc":"Issues a PUT request to the given url, raising an exception in case of failure.If the request does not fail, the response is returned.See request!/5 for more detailed information.","ref":"Astra.Rest.Http.html#put!/4","title":"Astra.Rest.Http.put!/4","type":"function"},{"doc":"Issues an HTTP request using a Request struct.This function returns {:ok, response}, {:ok, async_response}, or {:ok, maybe_redirect} if the request is successful, {:error, reason} otherwise.Redirect handlingIf the option :follow_redirect is given, HTTP redirects are automatically follow if the method is set to :get or :head and the response's status_code is 301, 302 or 307.If the method is set to :post, then the only status_code that get's automatically followed is 303.If any other method or status_code is returned, then this function returns a returns a {:ok, %HTTPoison.MaybeRedirect{}} containing the redirect_url for you to re-request with the method set to :get.Examplesrequest = %HTTPoison.Request{ method: :post, url: &quot;https://my.website.com&quot;, body: &quot;{\\&quot;foo\\&quot;: 3}&quot;, headers: [{&quot;Accept&quot;, &quot;application/json&quot;}] } request(request)","ref":"Astra.Rest.Http.html#request/1","title":"Astra.Rest.Http.request/1","type":"function"},{"doc":"Issues an HTTP request with the given method to the given url.This function is usually used indirectly by get/3, post/4, put/4, etcArgs:method - HTTP method as an atom (:get, :head, :post, :put, :delete, etc.)url - target url as a binary string or char listbody - request body. See more belowheaders - HTTP headers as an orddict (e.g., [{&quot;Accept&quot;, &quot;application/json&quot;}])options - Keyword list of optionsBody: see type HTTPoison.RequestOptions: see type HTTPoison.RequestThis function returns {:ok, response}, {:ok, async_response}, or {:ok, maybe_redirect} if the request is successful, {:error, reason} otherwise.Redirect handlingIf the option :follow_redirect is given, HTTP redirects are automatically follow if the method is set to :get or :head and the response's status_code is 301, 302 or 307.If the method is set to :post, then the only status_code that get's automatically followed is 303.If any other method or status_code is returned, then this function returns a returns a {:ok, %HTTPoison.MaybeRedirect{}} containing the redirect_url for you to re-request with the method set to :get.Examplesrequest(:post, &quot;https://my.website.com&quot;, &quot;{\\&quot;foo\\&quot;: 3}&quot;, [{&quot;Accept&quot;, &quot;application/json&quot;}])","ref":"Astra.Rest.Http.html#request/5","title":"Astra.Rest.Http.request/5","type":"function"},{"doc":"Issues an HTTP request with the given method to the given url, raising an exception in case of failure.request!/5 works exactly like request/5 but it returns just the response in case of a successful request, raising an exception in case the request fails.","ref":"Astra.Rest.Http.html#request!/5","title":"Astra.Rest.Http.request!/5","type":"function"},{"doc":"Starts HTTPoison and its dependencies.","ref":"Astra.Rest.Http.html#start/0","title":"Astra.Rest.Http.start/0","type":"function"},{"doc":"Requests the next message to be streamed for a given HTTPoison.AsyncResponse.See request!/5 for more detailed information.","ref":"Astra.Rest.Http.html#stream_next/1","title":"Astra.Rest.Http.stream_next/1","type":"function"},{"doc":"","ref":"Astra.Rest.Http.html#t:body/0","title":"Astra.Rest.Http.body/0","type":"type"},{"doc":"","ref":"Astra.Rest.Http.html#t:headers/0","title":"Astra.Rest.Http.headers/0","type":"type"},{"doc":"","ref":"Astra.Rest.Http.html#t:method/0","title":"Astra.Rest.Http.method/0","type":"type"},{"doc":"","ref":"Astra.Rest.Http.html#t:options/0","title":"Astra.Rest.Http.options/0","type":"type"},{"doc":"","ref":"Astra.Rest.Http.html#t:params/0","title":"Astra.Rest.Http.params/0","type":"type"},{"doc":"","ref":"Astra.Rest.Http.html#t:request/0","title":"Astra.Rest.Http.request/0","type":"type"},{"doc":"","ref":"Astra.Rest.Http.html#t:url/0","title":"Astra.Rest.Http.url/0","type":"type"},{"doc":"AstraAn elixir plugin for interacting with DataStax Astra or any stargate.io fronted storage!Currently supportsREST APIDocument APIGraphQL/Schema should be available soon.To use, setup an Astra instance at https://astra.datastax.com.","ref":"readme.html","title":"Astra","type":"extras"},{"doc":"The package can be installed by adding astra to your list of dependencies in mix.exs:def deps do [ {:astra, &quot;~&gt; 0.1.0&quot;} ] endTo connect to Astra add something like the following to your config.exs:config :astra, id: System.get_env(&quot;ASTRA_ID&quot;), #this is your astra cluster id region: System.get_env(&quot;ASTRA_REGION&quot;), #this is the region where your astra cluster is hosted username: System.get_env(&quot;ASTRA_USERNAME&quot;), password: System.get_env(&quot;ASTRA_PASSWORD&quot;)","ref":"readme.html#installation","title":"Astra - Installation","type":"extras"}]